/* GROOVE: GRaphs for Object Oriented VErification
 * Copyright 2003--2023 University of Twente
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, 
 * software distributed under the License is distributed on an 
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific 
 * language governing permissions and limitations under the License.
 *
 * $Id$
 */
package nl.utwente.groove.lts;

/** LTS filter values. */
public enum Filter {
    /** No filtering: all states shown (up to state bound). */
    NONE("None"),
    /** States and transitions of the spanning tree. */
    SPANNING("Spanning tree"),
    /** Only traces from start to result states. */
    RESULT("Result traces"), ;

    private Filter(String name) {
        this.name = name;
    }

    @Override
    public String toString() {
        return this.name;
    }

    private final String name;
}