/* GROOVE: GRaphs for Object Oriented VErification
 * Copyright 2003--2023 University of Twente
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * $Id$
 */
package nl.utwente.groove.util;

import nl.utwente.groove.graph.Graph;
import nl.utwente.groove.util.parse.FormatErrorSet;

/**
 * Interface for graph checkers
 * @author Arend Rensink
 * @version $Revision$
 */
public interface Checker<G extends Graph> {
    /** Checks a given graph.
     * @param graph the graph to be checked
     * @return the set of errors found in {@code graph} by this checker
     */
    FormatErrorSet check(G graph);
}
